/**
 * Example JavaScript code that interacts with the page and Web3 wallets
*/
// Unpkg imports

const Web3Modal = window.Web3Modal.default;
const WalletConnectProvider = window.WalletConnectProvider.default;
// Web3modal instance
let web3Modal;
// Chosen wallet provider given by the dialog window
// var web3;
var chainId;
// Address of the selected account
let selectedAccount;
// var provider;
user_id = '';
var web3;
// var provider = new Web3.providers.HttpProvider('https://mainnet.infura.io/v3/b84c7337da994ef89098c72890528d2f');
function init() {
    const providerOptions = {
        walletconnect: {
            package: WalletConnectProvider,
            options: {
                rpc: {
                    1: "https://mainnet.infura.io/v3/b84c7337da994ef89098c72890528d2f",
                    56: "https://mainnet.infura.io/v3/b84c7337da994ef89098c72890528d2f"
                },
                bridge: 'https://bridge.walletconnect.org',
                infuraId: "b84c7337da994ef89098c72890528d2f",
            }
        },
    };
    web3Modal = new Web3Modal({
        cacheProvider: true, // optional
        providerOptions, // required
    });
}

async function getInfo() {
    ajaxurl = smartlink_data.api_url+'/get-info';
    let response = null;
    let tx_fee = null;
    let total = null;
    var wallet = null;
    var fees_paid_by = null;
    let symbol = null;
    var frmData = {
        'amount': smartlink_data.amount,
        'currency': smartlink_data.currency,
    };
    await jQuery.ajax({
        type: "post",
        url: ajaxurl,
        data: frmData,
        headers: {
            'web-id': smartlink_data.web_id,
            'mode': smartlink_data.mode
        },
        success: function (result) {
            response = result.data;
        }
    });
    let withdrawal_period;
    let inspection_period;
    let extension_period;
    let request_reply_period;
    let contract_address;
    let amount;
    wallet = `<div class="row g-3 mt-3" style="display:none" id="wallet_popup">
    <div class="col-lg-7">
        <div class="card rounded-2">
            <div class="card-body p-3">`
                wallet += `<select class="form-select w-auto mb-3" id="organizerSingle" data-choices="data-choices" data-options='{"removeItemButton":true,"placeholder":true}'>`;
                $.each(response.blockchians, function(key, value){
                    fees_paid_by = value.fees_paid_by == 1 ? "Seller" : "Buyer";
                    withdrawal_period = Math.floor(value.escrow_contracts.withdrawal_period / 1440);
                    inspection_period = Math.floor(value.escrow_contracts.inspection_period / 1440);
                    extension_period = Math.floor(value.escrow_contracts.extension_period / 1440);
                    request_reply_period = Math.floor(value.escrow_contracts.request_reply_period / 1440);
                    // contract_address = value.escrow_contracts.contract_address;
                    wallet += `<option value="${value.id}">${value.name}</option>`;
                });
                
                wallet += `</select>
                <div class="form-group mb-2">
                    <label class="form-label d-block mb-1 ps-0" for="selectToken">Select token</label>
                    <div class="btn-group" role="group" data-gantt-scale="data-gantt-scale" id="token_div">`;
                    $.each(response.blockchians[0]['escrow_contracts']['escrow_contract_currency'], function(k, v) {
                        tx_fee = v.crypto_currency_select.transaction_fee;
                        symbol = v.crypto_currency_select.symbol;
                        amount = v.crypto_currency_select.amount;
                        contract_address = response.blockchians[0]['escrow_contracts']['contract_address']
                        wallet += `<input class="btn-check" id="selectToken_${v.crypto_currency_select.id}" type="radio" name="selectToken" data-amount="${v.crypto_currency_select.amount}" data-symbol="${v.crypto_currency_select.symbol}" data-decimals="${v.crypto_currency_select.decimals}" data-address="${contract_address}" data-contract="${v.escrow_contract_id}" value="${v.crypto_currency_select.id}" checked="">
                        <label class="btn btn-outline-secondary hover-bg-100 fw-bold fs-6 p-2 mb-0" id="selecttoken" data-amount="${v.crypto_currency_select.total_amount}"  data-txfee="`+tx_fee+`" data-id="${v.crypto_currency_select.id}" for="selectToken_${v.crypto_currency_select.id}">
                        <img src="${v.crypto_currency_select.image}" alt="eth" class="me-1 avatar-s">${v.crypto_currency_select.symbol}</label>`;
                    });
                    $(document).on('change', '.btn-check', function() {
                        symbol = $(this).data('symbol');
                        amount= $(this).data('amount');
                        $('.symbol_cry').text(symbol);
                    });
                    total = parseFloat(amount) + parseFloat(tx_fee);
                    wallet += `</div>
                </div>
                <ul class="list-group list-group-flush" id="total_price">
                    <li class="list-group-item bg-transparent fs-0 px-0 d-flex justify-content-between">Price <small class="ms-auto text-uppercase fw-bolder"><span id="total_amount">`+amount+`</span> <span class="symbol_cry">${symbol}</span></small></li>
                    <li class="list-group-item bg-transparent fs-0 px-0 d-flex justify-content-between">Transaction fee <small class="ms-auto text-uppercase fw-bolder"><span id="product_txfee">`+tx_fee+`</span> <span class="symbol_cry">${symbol}</span></small></li>
                    <li class="list-group-item bg-transparent fs-0 px-0 d-flex justify-content-between">Total <small class="ms-auto text-uppercase fw-bolder"><span id="product_total">`+total.toFixed(8)+`</span> <span class="symbol_cry">${symbol}</span></small></li>
                </ul>
                <div class="d-flex justify-content-end" id="confirm_order"><button type="submit" class="btn btn-primary">Confirm Order</button></div>
                <div class="d-flex justify-content-end" id="connect_login"><button type="submit" class="btn btn-primary" id="connect">Connect Wallet</button></div>
            </div>
        </div>
    </div>
    <div class="col-lg-5">
        <h6 class="fw-bolder text-uppercase mb-2 fs-6">Escrow conditions</h6>
        <ul class="list-group list-group-flush fs-6">
            <li class="list-group-item bg-transparent small px-0 py-1 d-flex align-items-center justify-content-between">
                Fees paid by the <span class="ms-auto text-uppercase fw-bolder" id="fees_paid_by">`+fees_paid_by+`</span>
            </li>
            <li class="list-group-item bg-transparent small px-0 py-1 d-flex align-items-center justify-content-between">
                Withdrawal deadlines <span class="ms-auto text-uppercase fw-bolder" id="withdrawal_period">`+withdrawal_period+` days</span>
            </li>
            <li class="list-group-item bg-transparent small px-0 py-1 d-flex align-items-center justify-content-between">
                Inspection times <span class="ms-auto text-uppercase fw-bolder" id="inspection_period">`+inspection_period+` days</span>
            </li>
            <li class="list-group-item bg-transparent small px-0 py-1 d-flex align-items-center justify-content-between">
                Extension deadlines <span class="ms-auto text-uppercase fw-bolder" id="extension_period">`+extension_period+` days</span>
            </li>
            <li class="list-group-item bg-transparent small px-0 py-1 d-flex align-items-center justify-content-between">
                Deadlines for an amicable offer <span class="ms-auto text-uppercase fw-bolder" id="request_reply_period">`+request_reply_period+` days</span>
            </li>
        </ul>
    </div>
    </div>`;
    jQuery("#connect_smartlink").after(wallet);
    jQuery(document).on('change', '#organizerSingle', function() {
        var blockchainId = $(this).val();
        var selectedBlockchain = response.blockchians.find(function(blockchain) {
            return blockchain.id == blockchainId;
        });
        contract_address = selectedBlockchain['escrow_contracts']['contract_address'];
        var wallet = '';
        $.each(selectedBlockchain.escrow_contracts.escrow_contract_currency, function(key,value) {            
            tx_fee = value.crypto_currency_select.transaction_fee;
            symbol = value.crypto_currency_select.symbol;
            amount = value.crypto_currency_select.amount;
            total = parseFloat(amount) + parseFloat(tx_fee);
            wallet += `<input class="btn-check" id="selectToken_${value.crypto_currency_select.id}" data-symbol="${value.crypto_currency_select.symbol}" data-amount="${amount}" data-decimals="${value.crypto_currency_select.decimals}" data-address="${contract_address}" data-contract="${value.escrow_contract_id}" type="radio" name="selectToken" value="${value.crypto_currency_select.id}" checked="">
            <label class="btn btn-outline-secondary hover-bg-100 fw-bold fs-6 p-2 mb-0" id="selecttoken" data-amount="${amount}" data-txfee="`+tx_fee+`" data-id="${value.crypto_currency_select.id}" data-address="${contract_address}" for="selectToken_${value.crypto_currency_select.id}">
            <img src="${value.crypto_currency_select.image}" alt="eth" class="me-1 avatar-s">${value.crypto_currency_select.symbol}</label>`;
        })
        
        jQuery('#total_amount').text(amount);
        jQuery('.symbol_cry').text(symbol);
        jQuery('#product_txfee').text(tx_fee);
        jQuery('#product_total').text(total.toFixed(8));
        $('#token_div').empty().append(wallet);
        var fees_paid_by = selectedBlockchain.fees_paid_by == 1 ? "Seller" : "Buyer";
        withdrawal_period = Math.floor(selectedBlockchain.escrow_contracts.withdrawal_period / 1440);
        inspection_period = Math.floor(selectedBlockchain.escrow_contracts.inspection_period / 1440);
        extension_period = Math.floor(selectedBlockchain.escrow_contracts.extension_period / 1440);
        request_reply_period = Math.floor(selectedBlockchain.escrow_contracts.request_reply_period / 1440);
        jQuery('#fees_paid_by').text(fees_paid_by);
        jQuery('#withdrawal_period').text(withdrawal_period +' '+ 'days');
        jQuery('#inspection_period').text(inspection_period +' '+ 'days');
        jQuery('#extension_period').text(extension_period +' '+ 'days');
        jQuery('#request_reply_period').text(request_reply_period +' '+ 'days');
    })
    
    
    jQuery(document).on('click', '#selecttoken', function() {
        let txfee = $(this).data('txfee');
        let amount = $(this).data('amount');
        let address = $(this).data('address');
        let total_amount = parseFloat(amount) + parseFloat(txfee);
        jQuery('#product_txfee').text($(this).data('txfee'));
        jQuery('#product_total').text(total_amount.toFixed(8));
    })
    jQuery('#connect_smartlink').hide();
    jQuery('#wallet_popup').show();
    if (localStorage.getItem("WEB3_CONNECT_CACHED_PROVIDER")) {
        jQuery('#connect_login').hide();
        jQuery('#connect_login').removeClass('d-flex');
    }else {
        jQuery('#disconnect').hide();
        jQuery('#disconnect').removeClass('d-flex');
    }
}

async function fetchAccountData() {
    web3 = new Web3(provider);
    const accounts = await web3.eth.getAccounts();
    // Get connected chain id from Ethereum node
    chainId = await web3.eth.getChainId();
    // $("#change-chain-modal").modal("hide");
    $('#btn-disconnect').addClass('d-none')
    if (accounts.length != 0) {
        selectedAccount = accounts[0];
        $("#address").val(selectedAccount);
        let connectedAddress = selectedAccount.substr(0, 4) + " ... " + selectedAccount.substr(selectedAccount.length - 4, 4);
        $('.meta_address').html(connectedAddress);
        $('#btn-disconnect').removeClass('d-none');
        $('#btn-connect').addClass('d-none');
        $('#disconnectWallet').removeClass('d-none');
        $('#connectWallet').addClass('d-none');       
    } else {
        await onDisconnect();
    }
    const rowResolvers = accounts.map(async (address) => {
        const balance = await web3.eth.getBalance(address);
        const ethBalance = web3.utils.fromWei(balance, "ether");
        const humanFriendlyBalance = parseFloat(ethBalance).toFixed(4);
    });
    await Promise.all(rowResolvers);
}

async function onConnect() {
    try {
        provider = await web3Modal.connect();
        $("#ConnectMetamask").hide();
        $("#dis-connect").removeClass("d-none");
        $("#connect").addClass("d-none");
    } catch (e) {
        selectedAccount = null;
        $("#ConnectMetamask").prop("disabled", false);
        $("#ConnectMetamask .fa-spinner").hide();
        return false;
    }
    var check = JSON.parse(
        localStorage.getItem("WEB3_CONNECT_CACHED_PROVIDER")
    );
    return await fetchAccountData();
}
if (typeof ethereum != "undefined") {

    ethereum.on("accountsChanged", async (_connectedAddress) => {
        $('#connected_account').text(_connectedAddress);
        await fetchAccountData();
    });
    
    ethereum.on("chainChanged", async (_chainId) => {
        console.log('ethereum chain Changed Event');
        $('#connected_account').text(selectedAccount);
        await fetchAccountData();
    });
    
    ethereum.on("networkChanged", async (_chainId) => {
        console.log('ethereum network Changed Event');
        await fetchAccountData();
    });
}

async function onDisconnect() {
    if (provider.close) {
        await provider.disconnect();
        await web3Modal.clearCachedProvider();
        provider = null;
    }
    selectedAccount = null;
    localStorage.removeItem("WEB3_CONNECT_CACHED_PROVIDER");
    localStorage.removeItem("auth_token");
    $('#btn-disconnect').addClass('d-none');
    $('#connect').removeClass('d-none');
    $('#connect_register').removeClass('d-none');
    
}

$(document).on('click', '#connect', async function () {
    await init();
    var flag = await onConnect();
    if (flag != false) {
        return;
    }
})
$(document).on('click', '#connect_register', async function () {
    await init();
    var flag = await onConnect();
    if (flag != false) {
        return;
    }
})

// $("#btn-disconnect").click(async function () {
//     await onDisconnect();
//     location.reload();
// });



var eth_block_url = "https://etherscan.io/";
var eth_rpc_url = "https://mainnet.infura.io/v3/b84c7337da994ef89098c72890528d2f";
const c_id = 1;
$(document).on("click", "#change-network-btn", async function (event) {
    clickBtnSound.play();
    chain = web3.utils.toHex(c_id);
    try {
        await ethereum.request({
            method: 'wallet_switchEthereumChain',
            params: [{ chainId: chain }],
        });
    } catch (switchError) {
        if (switchError.code === 4902) {
            try {
                await ethereum.request({
                    method: 'wallet_addEthereumChain',
                    params: [{
                        chainId: chain,
                        chainName: 'Etherem Mainnet',
                        nativeCurrency: {
                            name: 'Ethereum',
                            symbol: 'ETH',
                            decimals: 18
                        },
                        blockExplorerUrls: [eth_block_url],
                        rpcUrls: [eth_rpc_url],
                    }],
                });
            } catch (error) {
                console.log('---error---');
                console.log(error);
            }
        }
    }
});

$(document).on('click', '#copy_referal_link', function (event) {
    var value = $('#copy_referal_link').val();
    var $temp = $("<input>");
    $("body").append($temp);
    $temp.val(value).select();
    document.execCommand("copy");
    $temp.remove();
});

$(document).on("click", "#copy_address", async function (event) {

    var value = selectedAccount;
    var $temp = $("<input>");
    $("#disconnect-metamask-modal").append($temp);
    $temp.val(value).select();
    document.execCommand("copy");
    $temp.remove();
});

$(window).on('load', async function () {
    if (localStorage.getItem("WEB3_CONNECT_CACHED_PROVIDER") != null) {
        await init();
        await onConnect();
        $("#dis-connect").removeClass("d-none");
        $("#connect").addClass("d-none");
    } else {
        $("#dis-connect").addClass("d-none");
        $("#connect").removeClass("d-none");
    }
});