<?php

/*
Plugin Name:        Smartlink Crypto Payment Gateway
Description:        Welcome to the Smartlink WooCommerce Plugin Setup! Setting up your Smartlink payment gateway is a breeze, but first, let's ensure you have your Smartlink Merchant ID and API Key handy. If you do not have these details yet, you can easily obtain them by logging into your <a target="_blank" href="https://pay.smartlink.so/">Smartlink merchant account.</a>
Version:        1.0.5
Author:         Smartlink
Author URI:         https://pay.smartlink.so/
Requires at least: 5.7
Tested up to: 6.1


 *
 * Smartlink Crypto Payment Gateway is free software:
 * you can redistribute/resell it and/or modify it under the terms of the
 * GNU General Public License as published by  the Free Software Foundation,
 * either version 2 of the License, or any later version.
 *
 * Smartlink Crypto Payment Gateway is distributed
 * in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
*/


if (! defined('ABSPATH')) {
    exit;
}

$dir_arr = wp_upload_dir();

DEFINE('SMARTLINK', 'smartlink');
DEFINE('SMARTLINK_DIR_PATH', plugin_dir_path(__FILE__));
DEFINE('SMARTLINK_API_URL', 'https://pay.smartlink.so/api');
DEFINE('SMARTLINK_URL', 'https://pay.smartlink.so/');
DEFINE('SMARTLINK_API_VERSION', 'v3');
DEFINE('SMARTLINK_API_URL_ALL', 'https://pay.smartlink.so/');
DEFINE('SMARTLINK_PREVIEW', 'smartlinkadmin');
DEFINE('SMARTLINK_PAYMENT_FAIL', site_url('payment-fail'));
DEFINE('SMARTLINK_WEBHOOK_URL', site_url('?smartlink_webhook'));
DEFINE('SMARTLINK_VERSION', '1.0.4');
DEFINE('SMARTLINK_ADMIN', admin_url('admin.php?page='));
DEFINE('SMARTLINK_DIR', $dir_arr['basedir'] . '/' . SMARTLINK . '/');
DEFINE('SMARTLINK_DIR2', $dir_arr['baseurl'] . '/' . SMARTLINK . '/');
DEFINE('SMARTLINK_IMG', plugins_url('/images/', __FILE__));
DEFINE('SMARTLINK_BASENAME', plugin_basename(__FILE__));
DEFINE('SMARTLINK_PERMISSION', 'add_users');
DEFINE('SMARTLINK_WORDPRESS', true);
DEFINE('SMARTLINK_RATES', wp_json_encode(array( 'USD' => 'US Dollar' )));
DEFINE('SMARTLINK_INV_PENDING', 0);
DEFINE('SMARTLINK_INV_PAID', 1);
DEFINE('SMARTLINK_INV_UNDER_PAID', 2);
DEFINE('SMARTLINK_INV_OVER_PAID', 3);
DEFINE('SMARTLINK_INV_EXPIRED', 4);
DEFINE('SMARTLINK_ECR_SKEY', 'Smartlink');
DEFINE('SMARTLINK_ECR_CIPHERING', 'AES-256-CBC');
DEFINE('SMARTLINK_ECR_OPTIONS', 0);
DEFINE('SMARTLINK_ECR_IV', 'Smartlink__iv');
unset($dir_arr);

require_once plugin_dir_path(__FILE__) . '/smartlink.php';


register_activation_hook(__FILE__, 'smartlink_activate');
register_deactivation_hook(__FILE__, 'smartlink_deactivate');

add_filter('plugin_action_links', 'smartlink_action_links', 10, 2);


if (function_exists('mb_stripos') && function_exists('mb_strripos') && function_exists('curl_init') && function_exists('mysqli_connect') && version_compare(phpversion(), '5.4.0', '>=')) {
    $smartlink = new SmartlinkClass();
}