<?php

if (!defined('ABSPATH') || !defined('SMARTLINK')) exit;


final class SmartlinkClass
{
	private $options 		= array();
	private $errors			= array();
	private $page 			= array();
	public $PageID;

	public function __construct()
	{
		DEFINE('SMARTLINK_PHP_FILES_PATH',    plugins_url('/includes/', __FILE__));
		DEFINE('SMARTLINK_IMG_FILES_PATH',    plugins_url('/images/', __FILE__));
		DEFINE('SMARTLINK_JS_FILES_PATH',     plugins_url('/js/', __FILE__));
		DEFINE('SMARTLINK_CSS_FILES_PATH',     plugins_url('/css/', __FILE__));

		$smartlink_user = "smartlink_user";
		$smartlink = substr(strtolower(preg_replace("/[^a-zA-Z]+/", "", base64_encode(home_url('/', 'http')))), -7, 5) . "_";
		if (!$smartlink || strlen($smartlink) < 5) $smartlink = "cnrm_";
		if (is_admin()) {
			$smartlink_user = "smartlink";
			$smartlink = "smartlink_";
		}
		DEFINE('SMARTLINK_COINS_HTMLID',      $smartlink_user);
		DEFINE('SMARTLINK_PREFIX_HTMLID',     $smartlink);
		$version = get_option(SMARTLINK . 'version');
		if (!$version || version_compare($version, SMARTLINK_VERSION) < 0) $this->smartlink_upgrade();
		elseif (is_admin()) smartlink_retest_dir();

		if (is_admin()) smartlink_retest_dir();
		$this->page = (isset($_GET['page']) && sanitize_key($_GET['page'])) ? sanitize_key($_GET['page']) : "";
		if ($this->page == SMARTLINK . "contact") {
			header("Location: " . SMARTLINK_ADMIN . SMARTLINK . "#i3");
			die;
		}
		if (is_admin()) {
			if ($this->errors && $this->page != 'smartlinkcredentials') add_action('admin_notices', array(&$this, 'admin_warning_smartlink'));
			if (!file_exists(SMARTLINK_DIR . "files") || !file_exists(SMARTLINK_DIR . "images") || !file_exists(SMARTLINK_DIR . "lockimg")) add_action('admin_notices', array(&$this, 'admin_warning_reactivate_smartlink'));
			add_action('admin_menu', 			array(&$this, 'admin_menu_smartlink'));
			add_action('init', array(&$this, 'admin_init_smartlink'));
			if (strpos($this->page, SMARTLINK) === 0)  add_action("admin_enqueue_scripts", array(&$this, "admin_scripts_smartlink"));

			if (in_array($this->page, array("smartlink", "smartlinkpayments", "smartlinkcredentials"))) add_action('admin_footer_text', array(&$this, 'admin_footer_text_smartlink'), 15);

			$this->smartlink_postRecordExists();
		} else {
			add_action("wp_enqueue_scripts", array(&$this, "front_scripts_smartlink"));
		}

		add_action('parse_request', array(&$this, 'callback_parse_request_smartlink'), 1);
		add_filter('v_forcelogin_whitelist', array(&$this, "smartlink_forcelogin_whitelist"), 10, 1);
	}

	public function smartlink_postRecordExists()
	{
		global $wpdb;
		$tablename = $wpdb->prefix . "posts";
		$SQL = "SELECT * FROM $tablename WHERE post_title = 'Crypto Checkout'";
		$dataVal = $wpdb->get_results($SQL);
		if ($wpdb->num_rows > 0) {
			$this->PageID = $dataVal[0]->ID;
		} else {
			$postArr = array(
				'post_title'    => wp_strip_all_tags('Crypto Checkout'),
				'post_content'  => '[dis_custom_ord]',
				'post_status'   => 'publish',
				'post_author'   => 1,
				'post_type'   => 'page',
			);
			$this->PageID = wp_insert_post($postArr);
		}
	}
	public function admin_scripts_smartlink(){ // Load admin side used JS,CSS

		wp_enqueue_style('cr-style-admin', plugins_url('/css/style.admin.css', __FILE__));
		wp_enqueue_style('cr-style-bootstrap-admin', plugins_url('/css/bootstrapcustom.min.css', __FILE__));
		wp_enqueue_style('cr-style', plugins_url('/css/style.front.css', __FILE__));
		wp_enqueue_style('cr-stylecss', plugins_url('/css/style.css', __FILE__));
		wp_enqueue_style('font-awsome-all', plugins_url('/css/font-awsome-all.css', __FILE__));
		wp_enqueue_style('bootstrapmin', plugins_url('/css/bootstrapmin.css', __FILE__));
		wp_enqueue_script('jquery.validate', plugins_url('/js/jquery.validate.js', __FILE__));
		wp_enqueue_script('cr-customjs', plugins_url('/js/crypto-custom.js', __FILE__));

		return true;
	}
	public function front_scripts_smartlink()
	{
		$web_id = get_option('woocommerce_smartlinkpayments_web_id');
		$settings = get_option('woocommerce_smartlinkpayments_settings');
		$mode = isset($settings['mode']) ? $settings['mode'] : '';
		$merchant_id = isset($settings['merchant_id']) ? $settings['merchant_id'] : '';
		$api_key = isset($settings['api_key']) ? $settings['api_key'] : '';
		// print_r($_GET('key'));
		// die();
		if (isset($_GET['key']) && $_GET['key'] != null) {
			$order_key = sanitize_text_field($_GET['key']);
			$order_id = wc_get_order_id_by_order_key($order_key);
			$order = wc_get_order($order_id);
			$total_amount = $order->get_total();
			$currency = $order->get_currency();
		}
		// $iv = SMARTLINK_ECR_IV;
		wp_enqueue_script('sl-jquery', plugins_url('/assets/js/jquery.min.js', __FILE__));
		wp_enqueue_style('sl-bootstrap-css', plugins_url('/assets/css/bootstrap.min.css', __FILE__));
		wp_enqueue_script('sl-all-min', plugins_url('/assets/js/all.min.js', __FILE__), array('sl-jquery'), null, true);
		wp_enqueue_style('cr-style', plugins_url('/css/style.front.css', __FILE__));
		wp_enqueue_style('cr-cryptocustom', plugins_url('/css/crypto-custom.css', __FILE__));
		wp_enqueue_style('font-awsome-all', plugins_url('/css/font-awsome-all.css', __FILE__));
		// wp_enqueue_script('sl-crypto', plugins_url('/assets/js/crypto-js.min.js', __FILE__), array('sl-all-min'), null, true);
		// wp_enqueue_script('sl-contract_abi', plugins_url('/assets/js/contract_abi.js', __FILE__), array('sl-all-min'), null, true);
		// wp_enqueue_script('sl-toaster', plugins_url('/assets/js/toastr.min.js', __FILE__), array('sl-all-min'), null, true);
		// wp_enqueue_style('sl-toaster-css', plugins_url('/assets/css/toastr.min.css', __FILE__));
		wp_enqueue_script('sl-web3', plugins_url('/js/web3.min.js', __FILE__), array('sl-all-min'), null, true);
		wp_enqueue_script('sl-web3-modal', plugins_url('/js/web3modal.js', __FILE__), array('sl-all-min'), null, true);
		wp_enqueue_script('sl-web3-provider', plugins_url('/js/web3-provider.min.js', __FILE__), array('sl-all-min'), null, true);
		wp_enqueue_script('sl-walletconnect', plugins_url('/js/walletconnect.js', __FILE__), array('sl-all-min'), null, true);
		wp_enqueue_script('sl-popup', plugins_url('/js/pay-popup.js', __FILE__), array('sl-all-min'), null, true);
		// wp_enqueue_script('sl-popup-webhook', plugins_url('/js/pay-webhook.js', __FILE__), array('sl-all-min'), null, true);
		// wp_localize_script('sl-popup', 'smartlink_data', array('api_url' => SMARTLINK_API_URL, 'web_id' => $web_id, 'mode' => $mode, 'amount' => $total_amount, 'currency' => $currency, 'order_id' => $order_id));
		wp_localize_script('sl-walletconnect', 'smartlink_data', array('api_url' => SMARTLINK_API_URL, 'api_key' => $api_key, 'merchant_id' => $merchant_id));

		add_action('wp_enqueue_scripts', 'smartlink_my_enqueue');
		return true;
	}
	public static function smartlink_my_enqueue()
	{
		wp_localize_script(
			'ajax-script',
			'my_ajax_object',
			array('ajax_url' => admin_url('admin-ajax.php'))
		);
	}

	private function save_settings_smartlink($flag = 1)
	{
		$arr = array();
		foreach ($this->options as $key => $value) {
			$boxkey = (strpos($key, "merchant_id") || strpos($key, "api_key")) ? true : false;
			if (!$boxkey) {
				$oldval = get_option(SMARTLINK . $key);
				if ($boxkey && $oldval != $value) $arr[$key] = array("old_key" => ($oldval ? substr($oldval, 0, -20) . "....." : "-empty-"), "new_key" => ($value ? substr($value, 0, -20) . "....." : "-empty-"));
				if ($flag == 1) {
					if ($key == "api_key") {
						update_option(SMARTLINK . $key, $value);
					} else {
						update_option(SMARTLINK . $key, $value);
					}
				}
			}
		}

		return true;
	}
	public function admin_init_smartlink()
	{
		global $wpdb;

		if (isset($_POST['ak_action']) && strpos($this->page, SMARTLINK) === 0) {
			switch (sanitize_text_field($_POST['ak_action'])) {
				case SMARTLINK . 'save_settings':
					if (!$this->errors) {
						$CoinType = sanitize_text_field($_POST['CoinOpt']);
						$cURL = SMARTLINK_API_URL . $CoinType . '/get-balance';
						$parm = array(
							'api_key'	=> sanitize_text_field($_POST[SMARTLINK . $CoinType . 'api_key']),
							'password'	=> sanitize_text_field($_POST[SMARTLINK . $CoinType . 'password']),
						);
						$connection = $this->smartlink_chkConnection($cURL, $parm);
						$this->save_settings_smartlink($connection['flag'], $connection['data']);
						if (isset($_POST['add_new']) && !empty($_POST['add_new'])) {
							$upqstr = 'updated=true&inew=true';
						}
						header('Location: ' . SMARTLINK_ADMIN . 'smartlink&' . $delqstr . $upqstr);
						die();
					}

					break;
				default:

					break;
			}
		}
		return true;
	}
	public function smartlink_chkConnection($url, $post = '')
	{
		$web_id = get_option('woocommerce_smartlinkpayments_web_id');
		$settings = get_option('woocommerce_smartlinkpayments_settings');
		$mode = isset($settings['mode']) ? $settings['mode'] : '';
		$header[] = "Accept: application/json";
		$userAgent = 'CR@' . SMARTLINK_API_VERSION . ',wordpress worwoocommerce-wordpress-master@' . SMARTLINK_VERSION;
		$curl = $url;
		$body = array(
			'merchant_id' => $post['merchant_id'],
			'api_key' => $post['api_key'],
			'web_id' => $web_id,
			'mode' => $mode
		);
		$args = array(
			'method'      => 'POST',
			'timeout'     => 45,
			'sslverify'   => false,
			'user-agent'  => $userAgent,
			'headers'     => array(
				'Content-Type'  => 'application/json'
			),
			'body'        => wp_json_encode($body),
		);
		$request = wp_remote_post($curl, $args);
		if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
			error_log(print_r($request, true));
		}

		$response = wp_remote_retrieve_body($request);
		return json_decode($response, true);
	}
	public function admin_header_smartlink()
	{
		global $current_user;

		$_administrator = $_editor = false;
		if (is_user_logged_in()) {
			$_administrator = in_array('administrator', $current_user->roles);
			$_editor 		= in_array('editor', 		$current_user->roles);
		}
		return true;
	}
	public function admin_footer_text_smartlink()
	{
		return sprintf(__("If you like <strong>Smartlink Crypto Payment Gateway</strong> please leave us a %s rating on %s. A huge thank you from Smartlink  in advance!", SMARTLINK), "<a href='https://wordpress.org/support/view/plugin-reviews/smartlink-payment-gateway?filter=5#postform' target='_blank'>&#9733;&#9733;&#9733;&#9733;&#9733;</a>", "<a href='https://wordpress.org/plugins/smartlink-crypto-payment-gateway/#reviews' target='_blank'>WordPress.org</a>");
	}
	public function admin_warning_smartlink()
	{
		echo wp_kses_normalize_entities('<div class="updated"><p>' . sprintf(__("<strong>%s Plugin is almost ready to use!</strong> All you need to do is to <a style='text-decoration:underline' href='%s'>update your plugin settings</a>", SMARTLINK), __('Smartlink Crypto Payment Gateway', SMARTLINK), SMARTLINK_ADMIN . SMARTLINK . "credentials") . '</p></div>');

		return true;
	}
	public function admin_warning_reactivate_smartlink()
	{
		echo wp_kses_normalize_entities('<div class="error"><p>' . sprintf(__("<strong>Please deactivate %s Plugin,<br>manually set folder %s permission to 0777 and activate it again.</strong><br><br>if you have already done so before, please create three folders below manually and set folder permissions to 0777:<br>- %s<br>- %s<br>- %s", SMARTLINK), __('Smartlink Crypto Payment Gateway', SMARTLINK), SMARTLINK_DIR2, SMARTLINK_DIR2 . "files/", SMARTLINK_DIR2 . "images/", SMARTLINK_DIR2 . "lockimg/") . '</p></div>');

		return true;
	}

	public function page_summary_smartlink(){ // Merchant Details page at admin panel
		global $wpdb;
		
		if ($this->errors) $message = "<div class='error'>".__('Please fix errors below:', SMARTLINK)."<ul><li>- ".implode("</li><li>- ", $this->errors)."</li></ul></div>";

		else $message = "";
		
		$web_id = get_option('woocommerce_smartlinkpayments_web_id');
		$email = get_option('woocommerce_smartlinkpayments_email');
		$merchant_name = get_option('woocommerce_smartlinkpayments_merchant_name');
		$merchant_image = get_option('woocommerce_smartlinkpayments_merchant_image');
		$whitelist_domain = get_option('woocommerce_smartlinkpayments_whitelist_domain');
		$fiat_currency = get_option('woocommerce_smartlinkpayments_fiat_currency');
		$platform = get_option('woocommerce_smartlinkpayments_platform');
		$redirect_url = get_option('woocommerce_smartlinkpayments_redirect_url');
	
		$admin_settings_html  = "<div class='wrap ".SMARTLINK."admin'>";
		$admin_settings_html .= $message;
		
		// $admin_settings_html .= SMARTLINK;
		$admin_settings_html .= "<div class='postbox crypto-wallets'>";

		$admin_settings_html .= "<div class='inside smartlinksummary' style='padding:20px;'>";
		
		
	
		$admin_settings_html_next = "";

		$admin_settings_html .= "<a name='i1'></a>";
		$admin_settings_html .= "<div class='table-responsive' style='overflow-x: hidden;'>";
		$admin_settings_html .= "<div class='row'>";

		
		$admin_settings_html .= $admin_settings_html_next."</div>";
		$admin_settings_html .= "<a name='i2'></a>";
		$admin_settings_html .= "<br><br><br>";
		$admin_settings_html .= "<div class='crypto-summary'>";
		$admin_settings_html .= "<div class='smartlinktitle wallet-title' style='margin-top: 10px;'>".__('Welcome to Smartlink Pay for WooCommerce !', SMARTLINK)."</div>";
		$admin_settings_html .= "<ul class='smartlinklist wallet-content'>";
		$admin_settings_html .= "<li class='disc-style'> ".sprintf(__("Setting up your Smartlink payment gateway is a breeze, but first, let's ensure you have your Smartlink Merchant ID and API Key handy. If you do not have these details yet, you can easily obtain them by logging into your <a href='%s' target='_blank'>Smartlink merchant account.</a> ", SMARTLINK), "https://pay.smartlink.so/")."</li>";
		$admin_settings_html .= "</ul>";
		$admin_settings_html .= "<br><br><br>";
		$admin_settings_html .= "<div class='crypto-summary'>";
		$admin_settings_html .= "<div class='smartlinktitle wallet-title' style='margin-top: 10px;'>".__('TUTORIAL', SMARTLINK)."</div>";
		$admin_settings_html .= "<ul class='smartlinklist wallet-content'>";
		$admin_settings_html .= "<li class='disc-style'> ".sprintf(__("In the following steps, we'll guide you through how to input your Merchant ID and API Key, essential for linking your WooCommerce store to the Smartlink ecosystem.", SMARTLINK))."</li>";
		$admin_settings_html .= "<li ><b> ".sprintf(__('Displayed Title at Checkout: ')).'</b>'.sprintf(__("In the following steps, we'll guide you through how to input your Merchant ID and API Key, essential for linking your WooCommerce store to the Smartlink ecosystem.", SMARTLINK))."</li>";
		$admin_settings_html .= "<li ><b> ".sprintf(__('Merchant ID: ')).'</b>'.sprintf(__('This is your unique identifier within the Smartlink ecosystem. It allows Smartlink to recognize your business and link transactions to your merchant account. Once your Point of Sale is created you will find your Merchant ID in the menu "Payment Gateway" within Smartlink application.', SMARTLINK))."</li>";
		$admin_settings_html .= "<li ><b> ".sprintf(__('API Key: ')).'</b>'.sprintf(__('This serves as the secret password between your WooCommerce store and Smartlink. It allows for secure communication of transaction details. Once your Point of Sale is created you will find your API Keys in the menu "Payment Gateway" (Tab "API Keys) within Smartlink application.', SMARTLINK))."</li>";
		$admin_settings_html .= "<li class='disc-style'>".sprintf(__("Enter these details in the appropriate fields within you WooCommerce module (WooCommerce > Setting > Payments (Tab) > Smartlink Payment Gateway) and click 'Save'. Now, you're all set to accept cryptocurrency payments with Smartlink! Welcome aboard.", SMARTLINK))."</li>";
		$admin_settings_html .= "</ul>";
		if ($web_id != '') {
			$admin_settings_html .= "<div class='smartlinktitle wallet-title' style='margin-top: 10px;'>" . __('Merchant Detail', SMARTLINK) . "</div>";
			$admin_settings_html .= "<ul class='smartlinklist wallet-content'>";
			$admin_settings_html .= "<li><b> Email : </b>" . sprintf(__($email ? $email : '-', SMARTLINK)) . "</li>";
			$admin_settings_html .= "<li><b> Merchant Name : </b>" . sprintf(__($merchant_name ? $merchant_name : '-', SMARTLINK)) . "</li>";
			// $admin_settings_html .= "<li><b> Merchant Image : </b>".sprintf(__($merchant_image, SMARTLINK))."</li>";
			$admin_settings_html .= "<li><b> Whitelist Domain : </b>" . sprintf(__($whitelist_domain ? $whitelist_domain : '-', SMARTLINK)) . "</li>";
			$admin_settings_html .= "<li><b> Fiat Currency : </b>" . sprintf(__($fiat_currency ? $fiat_currency : '-', SMARTLINK)) . "</li>";
			$admin_settings_html .= "<li><b> Platform : </b>" . sprintf(__($platform ? $platform : '-', SMARTLINK)) . "</li>";
			$admin_settings_html .= "<li><b> Redirect Url : </b>" . sprintf(__("<a href='%s' target='_blank'>Redirect Url.</a>", SMARTLINK), $redirect_url) . "</li>";
			$admin_settings_html .= "</ul>";
		}
		$admin_settings_html .= "</div></div></div></div></div>";


		echo wp_kses_normalize_entities($admin_settings_html);
		

	} 
	public function admin_menu_smartlink(){ // Smartlink Pay - admin sidebar menu diplay
		global $submenu;

		add_menu_page(
			__("Smartlink", SMARTLINK)		
			, __('Smartlink Pay', SMARTLINK)
			, SMARTLINK_PERMISSION
			, SMARTLINK
			, array(&$this, 'page_summary_smartlink'),
			plugins_url('/images/smartlink-logo-icon.png', __FILE__),
			'21.777'
		);

		return true;
	}
	public function callback_parse_request_smartlink()
	{

		if (in_array(
			strtolower($this->smartlink_right($_SERVER["REQUEST_URI"], "/", false)),
			array(
				"?smartlink.webhook", "index.php?smartlink.webhook", "?smartlink_webhook",
				"index.php?smartlink_webhook", "?smartlink-webhook", "index.php?smartlink-webhook"
			)
		)) {

			ob_clean();

			$smartlink_private_keys = array();
			if ($smartlink_private_keys) DEFINE('SMARTLINK_PRIVATE_KEYS', wp_json_encode($smartlink_private_keys));
			include_once(plugin_dir_path(__FILE__) . "includes/smartlink.class.php");
			include_once(plugin_dir_path(__FILE__) . "includes/smartlink.webhook.php");

			ob_flush();

			die;
		}

		return true;
	}
	private function smartlink_upgrade(){

		global $wpdb;
		if ($wpdb->get_var("SHOW TABLES LIKE 'smartlink_payments'") != 'smartlink_payments') {
			$sql = "CREATE TABLE `smartlink_payments` (
				`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
				`order_id` varchar(50) NOT NULL DEFAULT '',
				`user_id` varchar(50) NOT NULL DEFAULT '',
				`crypto_amount` text NOT NULL DEFAULT '',
				`fiat_amount` text NOT NULL DEFAULT '',
				`fiat_currency` text NOT NULL DEFAULT '',
				`crypto_currency` text NOT NULL DEFAULT '',
				`trx_id` text NOT NULL DEFAULT '',
				`status` tinyint(1) NOT NULL DEFAULT '0',
				`created_at` datetime DEFAULT NULL,
				`updated_at` datetime DEFAULT NULL,
				PRIMARY KEY (`id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
			$wpdb->query($sql);
		}

		if ($wpdb->get_var("SHOW TABLES LIKE 'smartlink_webhook'") != 'smartlink_webhook') {
			$sql = "CREATE TABLE `smartlink_webhook` (
				`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
				`order_id` varchar(50) NOT NULL DEFAULT '',
				`type` tinyint(1) NOT NULL DEFAULT '0',
				`trx_id` varchar(255) NOT NULL DEFAULT '',
				`explorer_url` varchar(255) NOT NULL DEFAULT '',
				`paid_amount` double(20,8) NOT NULL DEFAULT '0.00000000',
				`paid_currency` varchar(255) NOT NULL DEFAULT '',
				`confirmation` tinyint(1) NOT NULL DEFAULT '0',
				`paid_date`datetime DEFAULT NULL,
				`created_at` datetime DEFAULT NULL,
				`updated_at` datetime DEFAULT NULL,
				PRIMARY KEY (`id`)

			) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

			$wpdb->query($sql);
		}

		$woocommerce_setting_data = [
			'enabled' => 'yes',
			'title' => 'Pay Using Smartlink',
			'api_key' => '',
			'merchant_id' => '',
			'smartlinkpay_btn' => 'Smartlink Pay',
		];
		update_option('woocommerce_smartlinkpayments_settings', $woocommerce_setting_data);
		smartlink_retest_dir();
		update_option(SMARTLINK . 'version', SMARTLINK_VERSION);
		ob_flush();
		return true;
	}
	public function smartlink_forcelogin_whitelist($arr)
	{
		$url = trim(get_site_url(), "/ ") . "/";

		$arr[] = $url . "?smartlink.callback";
		$arr[] = $url . "index.php?smartlink.callback";
		$arr[] = $url . "?smartlink_callback";
		$arr[] = $url . "index.php?smartlink_callback";
		$arr[] = $url . "?smartlink-callback";
		$arr[] = $url . "index.php?smartlink-callback]";

		return $arr;
	}
	public function smartlink_right($str, $findme, $firstpos = true)
	{
		$pos = ($firstpos) ? mb_stripos($str, $findme) : mb_strripos($str, $findme);

		if ($pos === false) return $str;
		else return mb_substr($str, $pos + mb_strlen($findme));
	}
}

function smartlink_activate()
{
	if (!function_exists('mb_stripos') || !function_exists('mb_strripos')) {
		echo sprintf(__("Error. Please enable <a target='_blank' href='%s'>MBSTRING extension</a> in PHP. <a target='_blank' href='%s'>Read here &#187;</a>", SMARTLINK), "http://php.net/manual/en/book.mbstring.php", "http://www.knowledgebase-script.com/kb/article/how-to-enable-mbstring-in-php-46.html");
		die();
	}
	if (!function_exists('curl_init')) {
		echo sprintf(__("Error. Please enable <a target='_blank' href='%s'>CURL extension</a> in PHP. <a target='_blank' href='%s'>Read here &#187;</a>", SMARTLINK), "http://php.net/manual/en/book.curl.php", "http://stackoverflow.com/questions/1347146/how-to-enable-curl-in-php-xampp");
		die();
	}
	if (!function_exists('mysqli_connect')) {
		echo sprintf(__("Error. Please enable <a target='_blank' href='%s'>MySQLi extension</a> in PHP. <a target='_blank' href='%s'>Read here &#187;</a>", SMARTLINK), "http://php.net/manual/en/book.mysqli.php", "http://crybit.com/how-to-enable-mysqli-extension-on-web-server/");
		die();
	}
	if (version_compare(phpversion(), '5.4.0', '<')) {
		echo sprintf(__("Error. You need PHP 5.4.0 (or greater). Current php version: %s", SMARTLINK), phpversion());
		die();
	}
	if (!defined('WOOCOMMERCE_VERSION')) {
		echo sprintf(__("The Smartlink Crypto Payment Gateway plugin requires WooCommerce 2.1 or higher to function. Please install <a href='%s'>latest version</a>.", SMARTLINK), admin_url('plugin-install.php?tab=search&type=term&s=WooCommerce+excelling+eCommerce+WooThemes+Beautifully'));
		die();
	} else if (true === version_compare(WOOCOMMERCE_VERSION, '2.1', '<')) {
		echo sprintf(__("Your WooCommerce version is too old. The Smartlink Ctypto Payment Gateway plugin requires WooCommerce 2.1 or higher to function. Please update to <a href='%s'>latest version</a>.", SMARTLINK), admin_url('plugin-install.php?tab=search&type=term&s=WooCommerce+excelling+eCommerce+WooThemes+Beautifully'));
		die();
	}
}

function smartlink_deactivate()
{
	update_option(SMARTLINK . 'version', '');
}
function smartlink_retest_dir()
{
	$elevel = error_reporting();
	error_reporting(0);
	$dir = plugin_dir_path(__FILE__) . "images/dir/";
	if (!file_exists(SMARTLINK_DIR . "files")) wp_mkdir_p(SMARTLINK_DIR . "files");
	if (!file_exists(SMARTLINK_DIR . "files/.htaccess")) copy($dir . "files/.htaccess", SMARTLINK_DIR . "files/.htaccess");
	if (!file_exists(SMARTLINK_DIR . "files/index.htm")) copy($dir . "files/index.htm", SMARTLINK_DIR . "files/index.htm");
	if (!file_exists(SMARTLINK_DIR . "lockimg")) wp_mkdir_p(SMARTLINK_DIR . "lockimg");
	if (!file_exists(SMARTLINK_DIR . "lockimg/index.htm")) copy($dir . "lockimg/index.htm", SMARTLINK_DIR . "lockimg/index.htm");
	if (!file_exists(SMARTLINK_DIR . "lockimg/image1.jpg")) copy($dir . "lockimg/image1.jpg", SMARTLINK_DIR . "lockimg/image1.jpg");
	if (!file_exists(SMARTLINK_DIR . "lockimg/image1.png")) copy($dir . "lockimg/image1.png", SMARTLINK_DIR . "lockimg/image1.png");
	if (!file_exists(SMARTLINK_DIR . "lockimg/image1b.png")) copy($dir . "lockimg/image1b.png", SMARTLINK_DIR . "lockimg/image1b.png");
	if (!file_exists(SMARTLINK_DIR . "lockimg/image2.jpg")) copy($dir . "lockimg/image2.jpg", SMARTLINK_DIR . "lockimg/image2.jpg");
	if (!file_exists(SMARTLINK_DIR . "box")) wp_mkdir_p(SMARTLINK_DIR . "box");
	if (!file_exists(SMARTLINK_DIR . "images")) {
		wp_mkdir_p(SMARTLINK_DIR . "images");

		$files = scandir($dir . "images");
		foreach ($files as $file)
			if (is_file($dir . "images/" . $file) && !in_array($file, array(".", "..")))
				copy($dir . "images/" . $file, SMARTLINK_DIR . "images/" . $file);
	}
	error_reporting($elevel);
	return true;
}

function smartlink_action_links($links, $file)
{
	static $this_plugin;

	if (false === isset($this_plugin) || true === empty($this_plugin)) {
		$this_plugin = SMARTLINK_BASENAME;
	}
	return $links;
}

if (!function_exists('smartlink_wc_gateway_load') && !function_exists('smartlink_wc_action_links')) {
	DEFINE('SMARTLINKWC', 'smartlink-woocommerce');
	DEFINE('SMARTLINKWC_2WAY', wp_json_encode(array("BTC", "BCH", "LTC", "ETH")));
	if (!defined('SMARTLINKWC_AFFILIATE_KEY')) {
		DEFINE('SMARTLINKWC_AFFILIATE_KEY', 	'smartlink');
		add_action('plugins_loaded', 		'smartlink_wc_gateway_load', 20);
		add_filter('plugin_action_links', 	'smartlink_wc_action_links', 10, 2);
	}
	function smartlink_wc_action_links($links, $file)
	{
		static $this_plugin;

		if (!class_exists('WC_Payment_Gateway')) return $links;

		if (false === isset($this_plugin) || true === empty($this_plugin)) {
			$this_plugin = dirname(plugin_basename(__FILE__)) . '/smartlink-wordpress.php';
		}

		if ($file == $this_plugin) {
			$settings_link = '<a href="' . admin_url('admin.php?page=wc-settings&tab=checkout&section=wc_gateway_smartlink') . '">' . __('Settings', SMARTLINKWC) . '</a>';
			array_unshift($links, $settings_link);
		}

		return $links;
	}
	function smartlink_wc_gateway_load()
	{
		$priority = 10;
		if (!class_exists('WC_Payment_Gateway') || class_exists('WC_Gateway_Smartlink')) return;
		add_filter('woocommerce_payment_gateways', 		'smartlink_wc_gateway_add');
		$web_id = get_option('woocommerce_smartlinkpayments_web_id');
		add_filter('woocommerce_get_return_url', 'smartlink_override_return_url', 10, 3);
		add_action('woocommerce_checkout_process', 'smartlink_customised_checkout_field_process');
		add_action('after_woocommerce_pay', 'smartlink_show_order_details', 10);
		add_filter('woocommerce_cancel_unpaid_order', '__return_false');
		function smartlink_wc_gateway_add($methods)
		{

			if (!in_array('WC_Gateway_smartlink', $methods)) {

				$methods[] = 'WC_Gateway_smartlink';
			}
			return $methods;
		}
		function smartlink_override_return_url($return_url, $order){ // Validate order data and generate order

			global $wpdb;
			$settings = get_option('woocommerce_smartlinkpayments_settings');
			$web_id = get_option('woocommerce_smartlinkpayments_web_id');
			$payment_title = isset($settings['title']) ? $settings['title'] : '';

			$OrdID = (true === version_compare(WOOCOMMERCE_VERSION, '3.0', '<')) ? $order->id  : $order->get_id();
			$s_url =  $_SERVER['HTTP_REFERER'];
			$test_order = new WC_Order($OrdID);
			$test_order_key = $test_order->get_order_key();
			$sss_url = $s_url . 'order-pay/' . $OrdID . '/?pay_for_order=true&key=' . $test_order_key;
			$modified_url = $sss_url;
			if ($order->get_payment_method_title() == 'Cash on delivery') {
				$modified_url = site_url("index.php/checkout/?order-received=" . $OrdID . "&key=" . $test_order_key . "");;
				return $modified_url;
			}
			if ($order->get_payment_method_title() === $payment_title) {
				$api_key = isset($settings['api_key']) ? $settings['api_key'] : '';
				$merchant_id = isset($settings['merchant_id']) ? $settings['merchant_id'] : '';
				$fiat_currency = $order->get_currency();
				$fiat_amount = $order->get_total();

				$cURL = SMARTLINK_API_URL . '/validate-data';

				$body = array(
					'api_key' => $api_key,
					'merchant_id' => $merchant_id,
					'fiat_currency' => $fiat_currency,
					'fiat_amount' => $fiat_amount
				);

				$args = array(
					'method'      => 'POST',
					'timeout'     => 45,
					'sslverify'   => false,
					'headers'     => array(
						'Accept' => 'application/json',
						'Content-Type' => 'application/json',

					),
					'body'        => json_encode($body)

				);
				$request = wp_remote_request($cURL, $args);

				if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
					error_log(print_r($request, true));
					return false;
				}

				$response = wp_remote_retrieve_body($request);
				$res = json_decode($response, true);
				$web_id = get_option('woocommerce_smartlinkpayments_web_id');
				if ($res['flag'] == 1) {


					$items = $order->get_items();
					$order_items = [];
					foreach ($items as $item) {
						$product        = $item->get_product();
						$order_items[] = $product->get_name();
					}

					$merged_product_names = implode(',', $order_items);
					$description = substr($merged_product_names, 0, 50);
					$cURL = SMARTLINK_API_URL . '/store-order-to-cache';

					$body = array(
						'web_id' => $web_id,
						'order_id' => $order->get_id(),
						'description' => $description,
						'fiat_currency' => $fiat_currency,
						'fiat_amount' => $fiat_amount,
					);

					$args = array(
						'method'      => 'POST',
						'timeout'     => 45,
						'sslverify'   => false,
						'headers'     => array(
							'Accept' => 'application/json',
							'Content-Type' => 'application/json',

						),
						'body'        => json_encode($body)

					);
					$request = wp_remote_request($cURL, $args);

					if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
						error_log(print_r($request, true));
						return false;
					}

					$response = wp_remote_retrieve_body($request);
					$res = json_decode($response, true);
					return $modified_url;
				} else {
					return $s_url;
				}
			}
		}

		function smartlink_get_info_paramaters(){ // Get merchant information
			
			$web_id = get_option('woocommerce_smartlinkpayments_web_id');
			if (isset($_GET['key']) && $_GET['key'] != null) {
				$order_key = sanitize_text_field($_GET['key']);
				$order_id = wc_get_order_id_by_order_key($order_key);
				$order = wc_get_order($order_id);
				$total_amount = $order->get_total();
				$currency = $order->get_currency();
			}
			$cURL = SMARTLINK_API_URL . '/get-info';
			if (!empty($web_id)) {
				$body = array(
					'amount' => $total_amount,
					'currency' => $currency
				);
				$args = array(
					'method'      => 'POST',
					'timeout'     => 45,
					'sslverify'   => false,
					'headers'     => array(
						'Accept' => 'application/json',
						'Content-Type' => 'application/json',
						'web-id' => $web_id,
					),
					'body'        => json_encode($body)

				);
				$request = wp_remote_request($cURL, $args);
				if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
					error_log(print_r($request, true));
					return false;
				}
				$response = wp_remote_retrieve_body($request);
				return json_decode($response, true);
			}
		}
		add_action('wc_ajax_smartlink_login', 'smartlink_login');

		function smartlink_login()
		{
			$web_id = get_option('woocommerce_smartlinkpayments_web_id');
			$settings = get_option('woocommerce_smartlinkpayments_settings');
			$mode = isset($settings['mode']) ? $settings['mode'] : '';
			$email = isset($_POST['email']) ? sanitize_text_field($_POST['email']) : '';
			$password = isset($_POST['password']) ? sanitize_text_field($_POST['password']) : '';
			$cURL = SMARTLINK_API_URL . '/login';
			if (!empty($web_id)) {
				$sign = smartlink_encrypt(json_encode(array(
					'email' => $email,
					'password' => $password
				)));
				$args = array(
					'method'      => 'POST',
					'timeout'     => 45,
					'sslverify'   => false,
					'headers'     => array(
						'Accept' => 'application/json',
						'Content-Type' => 'application/json',
						'web-id' => $web_id
					),
					'body' => json_encode(array(
						'sign' => $sign
					))
				);
				$request = wp_remote_request($cURL, $args);
				if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
					error_log(print_r($request, true));
					return false;
				}
				$response = wp_remote_retrieve_body($request);
				echo $response;
			}
		}

		add_action('wc_ajax_smartlink_register', 'smartlink_register');
		function smartlink_register()
		{
			$web_id = get_option('woocommerce_smartlinkpayments_web_id');
			$settings = get_option('woocommerce_smartlinkpayments_settings');
			$mode = isset($settings['mode']) ? $settings['mode'] : '';
			$first_name = isset($_POST['first_name']) ? sanitize_text_field($_POST['first_name']) : '';
			$last_name = isset($_POST['last_name']) ? sanitize_text_field($_POST['last_name']) : '';
			$date_of_birth = isset($_POST['date_of_birth']) ? sanitize_text_field($_POST['date_of_birth']) : '';
			$business_name = isset($_POST['business_name']) ? sanitize_text_field($_POST['business_name']) : '';
			$business_url = isset($_POST['business_url']) ? sanitize_text_field($_POST['business_url']) : '';
			$email = isset($_POST['email']) ? sanitize_text_field($_POST['email']) : '';
			$password = isset($_POST['password']) ? sanitize_text_field($_POST['password']) : '';
			$confirm_password = isset($_POST['confirm_password']) ? sanitize_text_field($_POST['confirm_password']) : '';
			$terms_and_condition = isset($_POST['terms_and_condition']) ? sanitize_text_field($_POST['terms_and_condition']) : '';
			$cURL = SMARTLINK_API_URL . '/signup';
			if (!empty($web_id)) {
				$sign = smartlink_encrypt(json_encode(array(
					'first_name' => $first_name,
					'last_name' => $last_name,
					'date_of_birthdate' => $date_of_birth,
					'business_name' => $business_name,
					'business_url' => $business_url,
					'email' => $email,
					'password' => $password,
					'confirm_password' => $confirm_password,
					'terms_and_condition' => $terms_and_condition
				)));
				$args = array(
					'method'      => 'POST',
					'timeout'     => 45,
					'sslverify'   => false,
					'headers'     => array(
						'Accept' => 'application/json',
						'Content-Type' => 'application/json',
						'web-id' => $web_id
					),
					'body' => json_encode(array(
						'sign' => $sign
					))
				);
				$request = wp_remote_request($cURL, $args);
				if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
					error_log(print_r($request, true));
					return false;
				}
				$response = wp_remote_retrieve_body($request);
				echo $response;
			}
		}


		function smartlink_show_order_details(){ // Invoice Page at front side

			// http://192.168.0.139/smart-link/public/checkout?web_id=V0x1aL9ehG&amount=5&currency=usd&order_id=86
			$response = smartlink_get_info_paramaters();
			$order_key = sanitize_text_field($_GET['key']);
			$order_id = wc_get_order_id_by_order_key($order_key);
			$order = wc_get_order($order_id);
			$items = $order->get_items();
			$symbol = get_woocommerce_currency_symbol();
			$order_items = '';
			foreach ($items as $item) {
				$product        = $item->get_product();
				$order_items .=  '<tr>
				<td style="width: 200px;">
				<div class="cr-plugin-cart-img">
				' . $product->get_image() . '
				</div>
				<div class="cr-plugin-cart-des">
				<p>' . $item->get_name() . '</p>
				</div>
				</td>
				<td style="text-align: center;">
				<span>' . $item->get_quantity() . '</span>
				</td>
				<td style="text-align: right;">
				<span>' . $symbol . ' ' . number_format($product->get_price(), 2) . '</span>
				</td>
				</tr>';
			}
			$order_date_time = get_post_time('F d, Y @H:i', false, $order->get_id(), true);
			$web_id = get_option('woocommerce_smartlinkpayments_web_id');
			$div_html = '<style>
			#order_review {
				display: none !important;
			}#openIframeButton{
				margin-left:420px;
				margin-top:10px;
			}
			.woocommerce-page.woocommerce-order-pay{
			display:block;
			}
				</style>
				
				<div class="cr-plugin-copy">
					<p>Copied</p>
				</div>
				<input type="hidden" id="base_url" value="' . site_url() . '">
					<input type="hidden" id="order_key" value="' . $order_key . '">
					<input type="hidden" id="order_status" value="' . $order->get_status() . '">
						<input type="hidden" id="web_id" value="' . $web_id . '">
						<input type="hidden" id="amount" value="' . $order->get_total() . '">
						<input type="hidden" id="currency" value="' . $order->get_currency() . '">
						<input type="hidden" id="order_id" value="' . $order->get_id() . '">
				<main id="site-content" class="theme-change-content" role="main">
					<article class="post-8 page type-page status-publish hentry" id="post-8">
						<div class="post-inner thin ">
							<div style="font-size:41px;">Order ID #' . $order_id . ' </div>
							<div class="entry-content">
								<div class="cr-plugin-main-box clearfix">
									<div class="cr-plugin-left clearfix">
										<div class="cr-plugin-shipping cr-plugin-shadow cr-plugin-mr-top clearfix">
											<div class="cr-plugin-billing-address">
												<h3 class="cr-plugin-title">Billing Address</h3>
												<p>' . $order->get_formatted_billing_address() . '</p>
											</div>
											<div class="cr-plugin-shipping-address">
												<h3 class="cr-plugin-title">Shipping Address</h3>
												<p>' . $order->get_formatted_shipping_address() . '</p>
											</div>
											
										</div>
										<div class="cr-plugin-history-list cr-plugin-shadow cr-plugin-mr-top" id="Webhook_history">
									</div>
									<div class="cr-plugin-right">
										<div class="cr-plugin-cart-summary cr-plugin-shadow cr-plugin-mr-top">
											<h3 class="cr-plugin-title">Cart Summary</h3>
											<div class="cr-plugin-cart-table">
												<div class="cr-plugin-cart-table-box">
													<table>
														<thead>
															<tr>
																<th>Product Info</th>
																<th style="text-align: center;">Quantity</th>
																<th style="text-align: right;">Price</th>
															</tr>
														</thead>
														<tbody>
															' . $order_items . '
														</tbody>
													</table>
												</div>
											</div>
											<div class="cr-plugin-payment-detail">
												<h3 class="cr-plugin-title">Payment Details</h3>
												<ul>
													<li>Total <span>' . $symbol . ' ' . number_format($order->get_subtotal(), 2) . '</span></li>
													<li>Shipping Fee <span>' . $symbol . '
															' . number_format($order->get_shipping_total(), 2) . '</span></li>
													<li>Total Taxes (2%) <span>' . $symbol . '
															' . number_format($order->get_shipping_tax(), 2) . '</span></li>
												</ul>
												<ul class="cr-plugin-payment-grand">
													<li>Grand Total <span>' . $symbol . ' ' . $order->get_total() . '</span></li>
												</ul>
												<button class="wp-element-button" id="openIframeButton">Pay</button>
												<div id="iframeContainer"></div>
											</div>

											
										</div>
										<div class="cr-plugin-brand">
										<span style="">Secured by</span>
										<a href="https://pay.smartlink.so/" target="_blank">
											<img src="' . plugins_url('assets/img/smartlink-logo.png', __FILE__) . '">
										</a>
									</div>
									</div>
								</div>
							</div>
						</div>
					</article>
				</main>';

			echo wp_kses_normalize_entities($div_html);
		}
		function smartlink_customised_checkout_field_process() 
		{


			if (sanitize_text_field($_POST['payment_method']) == 'smartlinkpayments') {
				$settings = get_option('woocommerce_smartlinkpayments_settings');
				// $api_key = isset($settings['api_key']) ? $settings['api_key'] : '';
				$web_id = get_option('woocommerce_smartlinkpayments_web_id');
				if ($web_id == '' || $settings['api_key'] == '' || $settings['merchant_id'] == '') wc_add_notice(__(' Something went wrong. Please Contact to Admin'), 'error');
			}
		}
		class WC_Gateway_Smartlink extends WC_Payment_Gateway
		{
			private $redirect           = '';
			private $options 		= array();

			public function __construct()
			{
				global $smartlink;
				$this->id                 	= 'smartlinkpayments';
				$this->method_title       	= __('Smartlink  Payment Gateway', SMARTLINKWC);
				// $this->method_description  	= "<a target='_blank' href='https://pay.smartlink.so/'></a>";
				$enabled = ((SMARTLINKWC_AFFILIATE_KEY == 'smartlink' && $this->get_option('enabled') === '') || $this->get_option('enabled') == 'yes' || $this->get_option('enabled') == '1' || $this->get_option('enabled') === true) ? true : false;
				if (true === version_compare(WOOCOMMERCE_VERSION, '2.1', '<')) {
					if ($enabled) $this->method_description .= '<div class="error"><p><b>' . sprintf(__("Your WooCommerce version is too old. The Smartlink Crypto Payment Gateway plugin requires WooCommerce 2.1 or higher to function. Please update to <a href='%s'>latest version</a>.", SMARTLINKWC), admin_url('plugin-install.php?tab=search&type=term&s=WooCommerce+excelling+eCommerce+WooThemes+Beautifully')) . '</b></p></div>';
				}
				// $this->method_description  .= "<b>" . __("Secure payments with virtual currency. <a target='_blank' href='https://bitcoin.org/'>What is Bitcoin?</a>", SMARTLINKWC) . '</b><br>';
				// if ($enabled) $this->method_description .= sprintf(__("If you use multiple stores/sites online, please create separate <a target='_blank' href='%s'>Smartlink Wallet </a> (with unique wallet api key/password ) for each of your stores/websites. Do not use the same Smartlink wallet with the same api key/password on your different websites/stores.", SMARTLINKWC), "https://pay.smartlink.so/") . '<br><br>';
				// else $this->method_description .= '<br>';
				$this->smartlink_init_form_fields();
				$this->smartlink_settings();
				add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'smartlink_set_validation_payment_gateways'));
				if (class_exists('WC_Subscriptions_Order')) {
				}
			}

			public function smartlink_set_validation_payment_gateways(){ // check Merchant credencial, update by admin

				global $current_tab;
				// http://192.168.0.139/wordpress-6.0/?smartlink_webhook
				$post_data = $this->get_post_data();
				// error_log(print_r($post_data));
				// die();
				if (!empty($post_data)) {
					$cURL = SMARTLINK_API_URL . '/verify-merchant-account';
					$parm = array(
						'merchant_id'   => sanitize_text_field($_POST['woocommerce_smartlinkpayments_merchant_id']),
						'api_key'       => sanitize_text_field($_POST['woocommerce_smartlinkpayments_api_key']),
					);
					$connection = $this->smartlink_chkConnection($cURL, $parm);
					if (!isset($connection['flag']) || $connection['flag'] != 1) {
						WC_Admin_Settings::add_error(__($connection['msg'], SMARTLINKWC));
					}
					// else{

					$web_id = isset($connection['data']['web_id']) ? $connection['data']['web_id'] : '';
					$email = isset($connection['data']['email']) ? $connection['data']['email'] : '';
					$merchant_name = isset($connection['data']['merchant_name']) ? $connection['data']['merchant_name'] : '';
					$whitelist_domain = isset($connection['data']['whitelist_domain']) ? $connection['data']['whitelist_domain'] : '';
					$merchant_image = isset($connection['data']['merchant_image']) ? $connection['data']['merchant_image'] : '';
					$fiat_currency = isset($connection['data']['fiat_currency']) ? $connection['data']['fiat_currency'] : '';
					$platform = isset($connection['data']['platform']) ? $connection['data']['platform'] : '';
					$redirect_url = isset($connection['data']['redirect_url']) ? $connection['data']['redirect_url'] : '';
					update_option('woocommerce_smartlinkpayments_web_id', $web_id);                     // save web_id in database
					update_option('woocommerce_smartlinkpayments_email', $email);                     	// save email in database
					update_option('woocommerce_smartlinkpayments_merchant_name', $merchant_name);       // save merchant_name in database
					update_option('woocommerce_smartlinkpayments_whitelist_domain', $whitelist_domain); // save whitelist_domain in database
					update_option('woocommerce_smartlinkpayments_merchant_image', $merchant_image);     // save merchant_image in database
					update_option('woocommerce_smartlinkpayments_fiat_currency', $fiat_currency);       // save fiat_currency in database
					update_option('woocommerce_smartlinkpayments_platform', $platform);                 // save platform in database
					update_option('woocommerce_smartlinkpayments_redirect_url', $redirect_url);         // save redirect_url in database
					$_POST['woocommerce_smartlinkpayments_web_id'] = $web_id;
					// $this->smartlink_get_info_paramaters();
					foreach ($this->get_form_fields() as $key => $field) {
						if ('title' !== $this->get_field_type($field)) {
							try {
								$field_value = $this->get_field_value($key, $field, $post_data);
								if ($key === 'api_key') {
									if ($parm['api_key'] == $field_value) {
										$this->settings[$key] =  $field_value;
									}
								} else {
									$this->settings[$key] = $field_value;
								}
							} catch (Exception $e) {
								$this->add_error($e->getMessage());
							}
						}
					}
					return update_option($this->get_option_key(), apply_filters('woocommerce_settings_api_sanitized_fields_' . $this->id, $this->settings), 'yes');
					// }
				}
			}

			public function smartlink_get_info_paramaters(){ // get merchant information

				$web_id = get_option('woocommerce_smartlinkpayments_web_id');
				if (isset($_GET['key']) && $_GET['key'] != null) {
					$order_key = sanitize_text_field($_GET['key']);
					$order_id = wc_get_order_id_by_order_key($order_key);
					$order = wc_get_order($order_id);
					$total_amount = $order->get_total();
					$currency = $order->get_currency();
				}
				$cURL = SMARTLINK_API_URL . '/get-info';
				if (!empty($web_id)) {
					$header = array(
						'Accept: application/json',
						'Content-Type: application/json',
						'web-id: ' . $web_id,
					);
					$body = array(
						'amount' => $total_amount,
						'currency' => $currency
					);
					$args = array(
						'method'      => 'POST',
						'timeout'     => 45,
						'sslverify'   => false,
						'headers'     => $header,
						'body'        => json_encode($body)
					);
					$request = wp_remote_request($cURL, $args);
					error_log('smartlink_get_info parameters: ' . $web_id);
					if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
						error_log(print_r($request, true));
						return false;
					}

					$response = wp_remote_retrieve_body($request);
					return json_encode($response, true);
				}
			}


			public function validate_fields()
			{
				$mode = isset($_POST['woocommerce_smartlink_settings']['mode']) ? sanitize_text_field($_POST['woocommerce_smartlink_settings']['mode']) : '';
				if (empty($mode) || !in_array($mode, array('live', 'test'))) {
					WC_Admin_Settings::add_error(__('Invalid payment gateway mode', SMARTLINKWC));
				}
				return true;
			}

			public function smartlink_init_form_fields(){ // Admin panel set merchant credencial page

				$this->form_fields = array(
					// 'mode'          => array(
					// 	'title'        => __('Select Option', SMARTLINKWC),
					// 	'type'         => 'select',
					// 	'options'      => array(
					// 		'live'      => __('Live', SMARTLINKWC),
					// 		'test'      => __('Test', SMARTLINKWC),
					// 	),
					// 	'default'      => 'test',
					// 	'description'  => __('Select payment gateway mode', SMARTLINKWC)
					// ),
					'title'			=> array(
						'title'       	=> __('Displayed Title at Checkout', SMARTLINKWC),
						'type'        	=> 'text',
						'default'     	=> __('Pay with Smartlink', SMARTLINKWC),
						'description' 	=> __("This is the name that will appear as your payment method during checkout. Make sure it's recognizable and aligns with your brand.", SMARTLINKWC)
					),
					'merchant_id'			=> array(
						'title'       	=> __('Merchant ID', SMARTLINKWC),
						'type'        	=> 'text',
						'default'     	=> __('', SMARTLINKWC),
						'description' 	=> __('This is your unique identifier within the Smartlink ecosystem. It allows Smartlink to recognize your business and link transactions to your merchant account.', SMARTLINKWC)
					),
					'api_key' 	=> array(
						'title'       	=> __('API key', SMARTLINKWC),
						'type'        	=> 'password',
						'default'     	=> __('', SMARTLINKWC),
						'description' 	=> __('This serves as the secret password between your WooCommerce store and Smartlink. It allows for secure communication of transaction details.', SMARTLINKWC)
					),
					'smartlinkpay_btn' 	=> array(
						'type'              => 'text',
						'default'=>__('Smartlink Pay', SMARTLINKWC),
						'custom_attributes' => array(
							'onclick' => "location.href='".admin_url('admin.php?page=smartlink')."'",
							'readonly'=>true,
						),
						'css'=>"background: #7856ff;width: 10%;padding: 10px 20px;border-radius: 22px;font-size: 15px;cursor: pointer;border: 1px black;color: white;font-weight: 400;display: inline-block;text-align: center;",
					),

				);
				return true;
			}
			private function smartlink_settings(){

				$this->title        = $this->get_option('title');
				// $this->title        = $this->get_option( 'merchant_id' );
				// $this->description  = $this->get_option( 'api_key' );

				$this->redirect     = $this->get_option('redirect');
				$this->description = $this->description . $this->smartlinkSetPaymnetOptDesc();
				if (!$this->title)										$this->title 		= __('', SMARTLINKWC);
				// if (!$this->description)								$this->description 	= __('', SMARTLINKWC);
				if (stripos($this->redirect, "http") !== 0)         $this->redirect     = '';
				return true;
			}
			public function smartlink_chkConnection($url, $post = ''){ // Check smartlink connection

				$settings = get_option('woocommerce_smartlinkpayments_settings');
				$web_id = get_option('woocommerce_smartlinkpayments_web_id');
				$header[] = "Accept: application/json";
				$userAgent = 'CR@' . SMARTLINK_API_VERSION . ',wordpress worwoocommerce-wordpress-master@' . SMARTLINK_VERSION;
				$curl = $url;
				$body = array(
					'merchant_id' => $post['merchant_id'],
					'api_key' => $post['api_key'],
					'web_id' => $web_id,
					'webhook_url'	=> SMARTLINK_WEBHOOK_URL,
				);
				$args = array(
					'method'      => 'POST',
					'timeout'     => 45,
					'sslverify'   => false,
					'user-agent'  => $userAgent,
					'headers'     => array(
						'Content-Type'  => 'application/json',
						'origin'  => $_SERVER['SERVER_NAME'],
					),
					'body'        => wp_json_encode($body),
				);
				$request = wp_remote_post($curl, $args);
				if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
					error_log(print_r($request, true));
				}

				$response = wp_remote_retrieve_body($request);
				return json_decode($response, true);
			}

			public function smartlinkSetPaymnetOptDesc()
			{

				global $woocommerce;
				$count = 0;
				$checkCoin = 0;
				$available_coins = array();
				if ($checkCoin == 0)
					if ($count == 0) {
						add_action('wp_enqueue_scripts', 'smartlink_select_payment_coin');
						// $temp = "<p class='noCoin' >This is a smartlink payment!</p>";
						$CryptoOpt = !empty($temp) ? (isset($Script) ? $Script : '') . $temp . '<input type="hidden" name="crpopt" id="crpopt" >' : '';
						$SetPaymentOpt = !empty($CryptoOpt) ? (isset($CoinSript) ? $CoinSript : '') . '<div>' . $CryptoOpt . '</div>' : '';
						return $SetPaymentOpt;
					}
				$tmp = '';
				$CryptoOpt = !empty($tmp) ? (isset($Script) ? $Script : '') . $tmp . '<input type="hidden" name="crpopt" id="crpopt" >' : '';
				$SetPaymentOpt = !empty($CryptoOpt) ? (isset($CoinSript) ? $CoinSript : '') . '<div>' . $CryptoOpt . '</div>' : '';

				return $SetPaymentOpt;
			}

			public function process_payment($order_id){ // Process payments comes on order
				global $woocommerce;
				global $wpdb;
				// $arr = smartlink_wc_currency_type();
				$order = new WC_Order($order_id);

				$order_id    = (true === version_compare(WOOCOMMERCE_VERSION, '3.0', '<')) ? $order->id          : $order->get_id();
				// $userID      = (true === version_compare(WOOCOMMERCE_VERSION, '3.0', '<')) ? $order->user_id     : $order->get_user_id();
				$order_total = (true === version_compare(WOOCOMMERCE_VERSION, '3.0', '<')) ? $order->order_total : $order->get_total();
				$order->update_status('pending', __('Awaiting payment notification from Smartlink', SMARTLINKWC));
				$payment_link = $this->get_return_url($order);
				$total = ($order_total >= 1000 ? number_format($order_total) : $order_total); //." ".$arr["user"];
				$orderpage = $this->get_return_url($order);

				$fiat_currency = $order->get_currency();
				$fiat_amount = $order->get_total();

				$user_id = $order->get_user_id();
				$crypto_amout = '';
				$crypto_currency = '';
				$trx_id = '';
				$status = SMARTLINK_INV_PENDING;
				$created_at  = gmdate('Y-m-d H:i:s');
				$updated_at  = gmdate('Y-m-d H:i:s');


				$data = array(
					'order_id' => $order_id,
					'user_id' => $user_id,
					'crypto_amount' => $crypto_amout,
					'fiat_amount' => $fiat_amount,
					'fiat_currency' => $fiat_currency,
					'crypto_currency' => $crypto_currency,
					'trx_id' => $trx_id,
					'status' => $status,
					'created_at' => $created_at,
					'updated_at' => $updated_at
				);

				$wpdb->insert('smartlink_payments', $data);
				// if (!get_post_meta( $order_id, '_smartlink_worder_orderid', true ))
				// {
				// 	update_post_meta( $order_id, '_smartlink_worder_orderid', 	    $order_id );
				// 	update_post_meta( $order_id, '_smartlink_worder_userid', 	    $userID );
				// 	update_post_meta( $order_id, '_smartlink_worder_createtime',   gmdate("c") );

				// 	update_post_meta( $order_id, '_smartlink_worder_orderpage',     $orderpage );
				// 	update_post_meta( $order_id, '_smartlink_worder_created',      gmdate("d M Y, H:i") );

				// 	update_post_meta( $order_id, '_smartlink_worder_currencies', $arr );
				// 	update_post_meta( $order_id, '_smartlink_worder_amountcrypto', $total );
				// 	update_post_meta( $order_ids, '_smartlink_worder_amountfiat',   (isset($totalFiat)?$totalFiat:$total) );
				// }
				$total_html = $total;
				if (isset($totalFiat)) $total_html .= " / <b> " . $totalFiat . "</b>";
				else $total_html = "<b>" . $total_html . "</b>";
				WC()->cart->empty_cart();
				return array(
					'result' 	=> 'success',
					'redirect'	=> $payment_link
				);
			}
		}

		function smartlinkwoocommerce_callback($user_id, $order_id, $payment_details){ 

			global $woocommerce;

			$gateways = $woocommerce->payment_gateways->payment_gateways();

			if (!isset($gateways['smartlinkpayments'])) return;
			$gateways['smartlinkpayments']->smartlinkcallback($user_id, $order_id, $payment_details);

			return true;
		}
	}
}


if (!function_exists('smartlink_select_payment_coin')) {
	function smartlink_select_payment_coin(){ // JS loads on checkout page

		wp_enqueue_script('jquery.validate', '/wp-includes/js/jquery/jquery.js');
		if (isset($_GET['pay_for_order'])) {
			wp_enqueue_script('paycheckout', plugins_url('/js/pay-webhook.js', __FILE__));
		} else {
			wp_enqueue_script('paycheckout', plugins_url('/js/pay-checkout.js', __FILE__));
		}
	}
}



// if (!function_exists('smartlink_getActCoins')) {
// 	function smartlink_getActCoins()
// 	{
// 		$url = SMARTLINK_API_URL_ALL . 'get-coins';
// 		$userAgent = 'CR@' . SMARTLINK_API_VERSION . ',wordpress worwoocommerce-wordpress-master@' . SMARTLINK_VERSION;

// 		$arrg = array(
// 			'headers'     => array(
// 				'Content-Type'  => 'application/json',
// 			),
// 			'timeout'     => (isset($timeout) ? $timeout : ''),
// 			'sslverify' => false,
// 			'user-agent' => $userAgent,
// 		);

// 		$request = wp_remote_get($url, $arrg);
// 		if (is_wp_error($request) || wp_remote_retrieve_response_code($request) != 200) {
// 			error_log(print_r($request, true));
// 		}
// 		$response = wp_remote_retrieve_body($request);

// 		$responseArr = json_decode($response, true);
// 		if ($response) {
// 			if ($responseArr['flag'] == 1) {
// 				return $responseArr['data'];
// 			}
// 		}
// 	}
// }
// function wpc_checkout_url_redirect() {

//         wp_redirect( site_url( 'checkout/form-checkout-detail/' ) ); // Assign custom internal page here
//         exit();

// }
add_filter('woocommerce_my_account_my_orders_actions', 'smartlink_change_my_account_my_orders_view_text_button', 10, 2);
if (!function_exists('smartlink_change_my_account_my_orders_view_text_button')) {
	function smartlink_change_my_account_my_orders_view_text_button($actions, $order)
	{
		if (is_wc_endpoint_url('orders')) {
			$order_id = (true === version_compare(WOOCOMMERCE_VERSION, '3.0', '<')) ? $order->id : $order->get_id();

			$payment_method = get_post_meta($order_id, '_payment_method', true);
			if ($payment_method == 'smartlinkpayments') {
				global $wpdb;
				$order_data = "SELECT * FROM smartlink_payments  WHERE order_id = " . $order_id . "";
				$order_details = $wpdb->get_results($order_data);
				// print_r($order_details[0]->status);
				if (!empty($order_details)) {

					if ($order_details[0]->status == SMARTLINK_INV_PAID) {
						$new_status = 'completed';
						// print_r($order->get_status());
						$order->update_status($new_status);
						unset($actions['pay']);
					}
					// $order_status = isset( $order->status ) ? $order->status : '';
					// if ( $order_status === 'wc-completed' ) {
					// 	unset( $actions['pay'] );
					// }



				}
			}

			return $actions;
		}
	}
}

function smartlink_webhook_data(){ // Receive webhook of payment

	global $wpdb;
	$order_id = isset($_GET['order_id']) ? sanitize_text_field($_GET['order_id']) : '';
	$order_query = "SELECT * FROM smartlink_payments WHERE order_id = '" . $order_id . "' ";
	$order_data = $wpdb->get_results($order_query);
	if (count($order_data) > 0) {
		$web_hook_data = '';
		$get_webhook_data = "SELECT * FROM smartlink_webhook WHERE order_id = '" . $order_id . "' ";
		$webhook_data = $wpdb->get_results($get_webhook_data);
		// print_r($order_id);
		if (count($webhook_data) > 0) {

			// print_r($order_id);
			$c_date = date("M d, Y H:i:s", strtotime($webhook_data[0]->created_at));

			$create_date = strtotime($webhook_data[0]->created_at);
			$c_date = date('Y-m-d H:i:s', $create_date);
			$seconds = strtotime(gmdate('Y-m-d H:i:s')) - strtotime($webhook_data[0]->created_at);
			$years = floor($seconds / (365 * 60 * 60 * 24));
			$months = floor(($seconds - $years * 365 * 60 * 60 * 24) / (30 * 60 * 60 * 24));
			$days    = floor($seconds / 86400);
			$hours   = floor(($seconds - ($days * 86400)) / 3600);
			$minutes = floor(($seconds - ($days * 86400) - ($hours * 3600)) / 60);
			$seconds = floor(($seconds - ($days * 86400) - ($hours * 3600) - ($minutes * 60)));
			if ($years > 0) {
				$diff = $years . " year(s) ago";
			} else if ($months > 0) {
				$diff = $months . " month(s) ago";
			} else if ($days > 0) {
				$diff = $days . " day(s) ago";
			} else if ($hours > 0) {
				$diff = $hours . " hour(s) ago";
			} else if ($minutes > 0) {
				$diff = $minutes . " minute(s) ago";
			} else {
				$diff = $seconds . " second(s) ago";
			}


			$web_hook_data .= '<div class="cr-plugin-history-box">
					<div class="cr-plugin-history">
					
					<div class="cr-plugin-history-des">
					<span><a href="' . $webhook_data[0]->explorer_url . '' . $webhook_data[0]->trx_id . '" target="_blank">' . substr($webhook_data[0]->trx_id, 0, 30) . '...</a></span>
					<p>' . number_format($webhook_data[0]->paid_amount, 8) . ' ' . $webhook_data[0]->paid_currency . '</p>
					</div>
					<div class="cr-plugin-history-date" title="' . $c_date . ' (UTC)"><span>' . $diff . '</span></div>
					</div>
					</div>';

			if ($order_data[0]->status == SMARTLINK_INV_PENDING || $order_data[0]->status == SMARTLINK_INV_UNDER_PAID) {
				$order = new WC_Order($order_id);
				// if($order->status == "pending"){
				// print_r($webhook_data[0]->trx_id);
				if ($webhook_data[0]->trx_id != "") {
					$result['trx_id'] = $webhook_data[0]->trx_id;
					$result['data'] = $web_hook_data;
					$result['flag'] = '1';
					echo wp_json_encode($result);
					return false;
				} else {
					$result['flag'] = '0';
					echo wp_json_encode($result);
					return false;
				}

				// }
			}
			if ($order_data[0]->status == SMARTLINK_INV_PAID ||  $order_data[0]->status == SMARTLINK_INV_OVER_PAID) {
				$order = new WC_Order($order_id);
				$order_key = $order->get_order_key();
				if ($order->status == "completed") {
					$url = site_url("index.php/checkout/?order-received=" . $order_id . "&key=" . $order_key . "");
					$result['link'] = $url;
					$result['data'] = $web_hook_data;
					$result['flag'] = '2';
					echo wp_json_encode($result);
					return false;
				}
			}
		} else {
			$result['flag'] = '0';
			echo wp_json_encode($result);
			return false;
		}
	}
}
add_action('wc_ajax_smartlink_webhook_data', 'smartlink_webhook_data');

if (!function_exists('smartlink_encrypt')) {
	function smartlink_encrypt($string)
	{
		$settings = get_option('woocommerce_smartlinkpayments_settings');
		$api_key = isset($settings['api_key']) ? $settings['api_key'] : '';
		$encrypt_method = "AES-256-CBC";
		$key = hash('sha256', $api_key);
		$secret_iv = SMARTLINK_ECR_IV;
		$iv = substr(hash('sha256', $secret_iv), 0, 16);
		$output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
		$output = base64_encode($output);
		return $output;
	}
}
if (!function_exists('smartlink_decrypt')) {
	function smartlink_decrypt($value)
	{
		$settings = get_option('woocommerce_smartlinkpayments_settings');
		$api_key = isset($settings['api_key']) ? $settings['api_key'] : '';
		$encrypt_method = "AES-256-CBC";
		$key = hash('sha256', $api_key);
		$secret_iv = SMARTLINK_ECR_IV;
		$iv = substr(hash('sha256', $secret_iv), 0, 16);
		$output = openssl_encrypt($value, $encrypt_method, $key, 0, $iv);
		$output = base64_decode($output);
		return $output;
	}
}

